
import java.awt.Desktop;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.ObjectInputStream;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Arrays;
import javax.swing.ImageIcon;
import javax.swing.JFrame;
import javax.swing.JOptionPane;
import javax.swing.UIManager;
import javax.swing.event.HyperlinkEvent;
import javax.swing.event.HyperlinkListener;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.TokenStream;
import org.apache.lucene.analysis.core.KeywordAnalyzer;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.index.DirectoryReader;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.index.Terms;
import org.apache.lucene.search.IndexSearcher;
import org.apache.lucene.search.Query;
import org.apache.lucene.search.ScoreDoc;
import org.apache.lucene.search.TopDocs;
import org.apache.lucene.search.highlight.Highlighter;
import org.apache.lucene.search.highlight.QueryScorer;
import org.apache.lucene.search.highlight.SimpleFragmenter;
import org.apache.lucene.search.highlight.TokenSources;
import org.apache.lucene.search.spell.LevensteinDistance;
import org.apache.lucene.search.spell.NGramDistance;
import org.apache.lucene.search.spell.SpellChecker;
import org.apache.lucene.search.spell.StringDistance;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;
import org.apache.lucene.util.QueryBuilder;

public class Search_Engine extends javax.swing.JFrame {

    private InfoEngine info = new InfoEngine();
    private Info settings;

    public Search_Engine() {
        initComponents();
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel2 = new javax.swing.JLabel();
        txt_search = new javax.swing.JTextField();
        btn_search = new javax.swing.JLabel();
        jScrollPane2 = new javax.swing.JScrollPane();
        area_status_search = new javax.swing.JEditorPane();
        btn_settings = new javax.swing.JLabel();
        prg_search = new javax.swing.JProgressBar();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Persia Search Engine");
        setIconImage(new ImageIcon(getClass().getResource("search-globe-icon.png")).getImage());
        setLocationByPlatform(true);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        jLabel2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/coollogo_com-3104440.png"))); // NOI18N

        txt_search.setFont(new java.awt.Font("Tahoma", 0, 14)); // NOI18N
        txt_search.setText("inforation sciense");

        btn_search.setIcon(new javax.swing.ImageIcon(getClass().getResource("/search-icon-png-25.png"))); // NOI18N
        btn_search.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btn_search.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_searchMouseReleased(evt);
            }
        });

        area_status_search.setEditable(false);
        area_status_search.setContentType("text/html"); // NOI18N
        jScrollPane2.setViewportView(area_status_search);

        btn_settings.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Settings-2-icon.png"))); // NOI18N
        btn_settings.setCursor(new java.awt.Cursor(java.awt.Cursor.HAND_CURSOR));
        btn_settings.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseReleased(java.awt.event.MouseEvent evt) {
                btn_settingsMouseReleased(evt);
            }
        });

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(javax.swing.GroupLayout.Alignment.TRAILING, layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                    .addComponent(prg_search, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jScrollPane2, javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(javax.swing.GroupLayout.Alignment.LEADING, layout.createSequentialGroup()
                        .addComponent(jLabel2)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(txt_search, javax.swing.GroupLayout.DEFAULT_SIZE, 463, Short.MAX_VALUE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(btn_search)
                        .addGap(4, 4, 4)
                        .addComponent(btn_settings)))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addContainerGap()
                        .addComponent(jLabel2))
                    .addGroup(layout.createSequentialGroup()
                        .addGap(24, 24, 24)
                        .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING)
                            .addComponent(btn_search)
                            .addComponent(txt_search, javax.swing.GroupLayout.PREFERRED_SIZE, 42, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(btn_settings))))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.DEFAULT_SIZE, 322, Short.MAX_VALUE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(prg_search, javax.swing.GroupLayout.PREFERRED_SIZE, 26, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(6, 6, 6))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        this.setExtendedState(JFrame.MAXIMIZED_BOTH);
        area_status_search.addHyperlinkListener(new HyperlinkListener() {

            @Override
            public void hyperlinkUpdate(HyperlinkEvent e) {
                hyperlinkActionpeformed(e);
            }
        });
        try {
            FileInputStream fis = new FileInputStream("Config.ini");
            ObjectInputStream ois = new ObjectInputStream(fis);
            settings = (Info) ois.readObject();
            ois.close();
            fis.close();
            info.setContents(settings.getContents());
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_formWindowOpened

    private void btn_settingsMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_settingsMouseReleased
        Settings settings = new Settings(info);
        settings.setModal(true);
        settings.setVisible(true);
    }//GEN-LAST:event_btn_settingsMouseReleased

    private void btn_searchMouseReleased(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_searchMouseReleased
        new Thread(new Runnable() {

            @Override
            public void run() {
                search(txt_search.getText().toLowerCase(), Paths.get(settings.getIndexPath(), "Index"));
            }
        }).start();
    }//GEN-LAST:event_btn_searchMouseReleased

    private void search(String str, Path input) {
        try {
            FSDirectory directory = FSDirectory.open(input);
            IndexReader reader = DirectoryReader.open(directory);
            Analyzer analyzer = new StandardAnalyzer();
            switch (settings.getAnalyzer()) {
                case "Standard":
                    analyzer = new StandardAnalyzer();
                    break;
                case "Keyword":
                    analyzer = new KeywordAnalyzer();
                    break;
            }
            QueryBuilder builder = new QueryBuilder(analyzer);
            Query query = null;
            if (settings.getQuery().equals("Boolean")) {
                query = builder.createBooleanQuery("body", str);
            } else {
                query = builder.createPhraseQuery("body", str);
            }
            IndexSearcher searcher = new IndexSearcher(reader);
            String[] correct = spellChecker(Paths.get(input.getParent().toString(), "Spell"), str);
            long start = System.currentTimeMillis();
            TopDocs hits = searcher.search(query, reader.numDocs());
            ScoreDoc[] scores = hits.scoreDocs;
            BoldFormatter formatter = new BoldFormatter();
            Highlighter highlighter = new Highlighter(formatter, new QueryScorer(query));
            highlighter.setTextFragmenter(new SimpleFragmenter(50));
            String html = "<html>"
                    + " <head>"
                    + "     <title>Results</title>"
                    + " </head>"
                    + "<body>";
            String body = "";
            int count = 0;
            String[] contents = (String[]) info.getContents().clone();
            Arrays.sort(contents);
            prg_search.setMaximum(hits.totalHits);
            for (int i = 0; i < hits.totalHits; i++) {
                Document tmp = searcher.doc(hits.scoreDocs[i].doc);
                String text = tmp.get("body");
                boolean cond = true;
                if (!info.getLanguage().equals("all")) {
                    cond &= info.getLanguage().equals(tmp.get("language"));
                }
                cond &= (info.getDate() <= Long.parseLong(tmp.get("date")));
                cond &= Arrays.binarySearch(contents, " " + tmp.get("type")) > 0;
                if (cond) {
                    int maxNumFragmentsRequired = 3;
                    String fragmentSeparator = "...";
                    Terms tpv = reader.getTermVector(hits.scoreDocs[i].doc, "body");
                    TokenStream tokenStream = TokenSources.getTokenStream(tpv);
                    String result = highlighter.getBestFragments(tokenStream, text, maxNumFragmentsRequired, fragmentSeparator);
                    body += "<p><a href='" + searcher.doc(hits.scoreDocs[i].doc).get("address") + "' style='text-decoration: none;font-size:16'>";
                    body += searcher.doc(hits.scoreDocs[i].doc).get("title") + "</a><br />";
                    body += "<span style='color:green;font-size:12'>" + searcher.doc(hits.scoreDocs[i].doc).get("address") + "</span><br />";
                    body += "<span style='color:gray;font-size:12'>" + result + "</span>";
                    body += "</p>";
                } else {
                    count++;
                }
                prg_search.setValue(i+1);
            }
            body += "</body></html>";
            reader.close();
            long end = System.currentTimeMillis();
            html += "<span style='color:gray;font-size:12'> About " + (hits.totalHits - count) + " results (" + (end - start) / 1000.0 + " seconds)</span><br /><br />";
            if (!correct[1].isEmpty() && !txt_search.getText().equalsIgnoreCase(correct[1])) {
                html += "<span style='color:red;font-size:16'>Did you mean: </span><a href='cmd:" + correct[1] + "' style='text-decoration: none'>" + correct[0] + "</a>";
            }
            html += body;
            area_status_search.setText(html);
            area_status_search.setCaretPosition(0);
            prg_search.setValue(0);
        } catch (Exception ex) {
            area_status_search.setText(area_status_search.getText() + "Please Wait..., There is error\n");
        }
    }

    private String[] spellChecker(Path input, String query) throws IOException {
        Directory dir = FSDirectory.open(input);
        SpellChecker spell = new SpellChecker(dir);
        StringDistance distance = null;
        if (settings.getStringDistance().equals("Levenshtein")) {
            distance = new LevensteinDistance();
        } else {
            distance = new NGramDistance();
        }
        spell.setStringDistance(distance);
        String res = "<span style='color:blue;font-size:16'>";
        String original = "";
        String[] split = query.split(" ");
        for (String word : split) {
            if (!spell.exist(word)) {
                String[] suggest = spell.suggestSimilar(word, 1);
                if (suggest.length >= 1) {
                    res += "<b><i>" + suggest[0].replace('ی', 'ي') + " </i></b>";
                    original += suggest[0] + " ";
                } else {
                    res += word + " ";
                    original += word + " ";
                }
            } else {
                res += word + " ";
                original += word + " ";
            }
        }
        res += "</span>";
        return new String[]{res, original.trim()};
    }

    private void hyperlinkActionpeformed(HyperlinkEvent e) {
        if (e.getEventType() == HyperlinkEvent.EventType.ACTIVATED) {
            try {
                if (e.getDescription().startsWith("cmd:")) {
                    txt_search.setText(e.getDescription().substring(4));
                    new Thread(new Runnable() {

                        @Override
                        public void run() {
                            search(txt_search.getText().toLowerCase(), Paths.get(settings.getIndexPath(), "Index"));
                        }
                    }).start();
                } else {
                    Desktop.getDesktop().open(new File(e.getDescription()));
                }
            } catch (Exception ex) {
            }
        }
    }

    public static void main(String args[]) {

        try {
            UIManager.setLookAndFeel("javax.swing.plaf.nimbus.NimbusLookAndFeel");
        } catch (Exception ex) {

        }
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Search_Engine().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JEditorPane area_status_search;
    private javax.swing.JLabel btn_search;
    private javax.swing.JLabel btn_settings;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JProgressBar prg_search;
    private javax.swing.JTextField txt_search;
    // End of variables declaration//GEN-END:variables
}
