
import java.io.FileNotFoundException;
import java.io.IOException;
import java.nio.file.Files;
import java.nio.file.LinkOption;
import java.nio.file.Path;
import java.nio.file.Paths;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import org.apache.commons.io.FileUtils;
import org.jsoup.Jsoup;
import org.jsoup.nodes.Document;

public class FetchWiki extends javax.swing.JDialog {

    boolean isThreadOn = true;

    public FetchWiki() {
        initComponents();
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        txt_dir_fetch = new javax.swing.JTextField();
        btn_browse_fetch = new javax.swing.JButton();
        btn_fetch = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        area_status_fetch = new javax.swing.JTextArea();
        prb_fetch = new javax.swing.JProgressBar();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Random pages of Wikipedia");
        setLocationByPlatform(true);
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jLabel1.setText("Directory:");

        txt_dir_fetch.setEditable(false);

        btn_browse_fetch.setText("Browse");
        btn_browse_fetch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_browse_fetchActionPerformed(evt);
            }
        });

        btn_fetch.setText("Fetch");
        btn_fetch.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_fetchActionPerformed(evt);
            }
        });

        area_status_fetch.setEditable(false);
        area_status_fetch.setColumns(40);
        area_status_fetch.setRows(5);
        jScrollPane1.setViewportView(area_status_fetch);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 617, Short.MAX_VALUE)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                    .addGap(8, 8, 8)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                            .addComponent(jLabel1)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(txt_dir_fetch)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(btn_browse_fetch)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(btn_fetch))
                        .addComponent(prb_fetch, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 601, Short.MAX_VALUE))
                    .addGap(8, 8, 8)))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 381, Short.MAX_VALUE)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                    .addContainerGap()
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel1)
                        .addComponent(txt_dir_fetch, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(btn_browse_fetch)
                        .addComponent(btn_fetch))
                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                    .addComponent(prb_fetch, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 294, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btn_browse_fetchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_browse_fetchActionPerformed
        JFileChooser open = new JFileChooser();
        open.setMultiSelectionEnabled(false);
        open.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        open.setDialogTitle("Open Directory");
        if (open.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
            txt_dir_fetch.setText(open.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_btn_browse_fetchActionPerformed

    private void btn_fetchActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_fetchActionPerformed
        try {
            Path p = Paths.get(txt_dir_fetch.getText());
            if (Files.exists(p) && Files.isDirectory(p, LinkOption.NOFOLLOW_LINKS)) {
                new Thread(new Runnable() {

                    @Override
                    public void run() {
                        area_status_fetch.setText("");
                        getRandomInfo();
                    }
                }).start();
            }
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_btn_fetchActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        isThreadOn = false;
        this.dispose();
    }//GEN-LAST:event_formWindowClosing

    private void getRandomInfo() {
        int num = 100;
        while (true) {
            try {
                num = Integer.parseInt(JOptionPane.showInputDialog(this, "Enter the number of pages to download from Wikipedia:", "Question", JOptionPane.INFORMATION_MESSAGE));
                if (num > 0) {
                    break;
                }
            } catch (Exception ex) {
            }
        }
        prb_fetch.setMaximum(num);
        btn_browse_fetch.setEnabled(false);
        btn_fetch.setEnabled(false);
        for (int i = 1; i <= num / 2; i++) {
            try {
                Document d = Jsoup.connect("https://en.wikipedia.org/wiki/Special:Random").timeout(10000).get();
                String name = d.baseUri();
                name = name.substring(name.lastIndexOf("/") + 1);
                String url = "https://en.wikipedia.org/w/index.php?title=" + name + "&printable=yes";
                Fetch(url);
                prb_fetch.setValue(i);
                String out = i + ": " + name;
                area_status_fetch.append(out + "\n");
            } catch (Exception ex) {
                area_status_fetch.append("Please Wait..., There is error\n");
                i--;
            }
            area_status_fetch.setCaretPosition(area_status_fetch.getText().length());
            if (!isThreadOn) {
                return;
            }
        }
        for (int i = 1; i <= num / 2; i++) {
            try {
                Document d = Jsoup.connect("https://fa.wikipedia.org/wiki/Special:Random").timeout(10000).get();
                String name = d.baseUri();
                name = name.substring(name.lastIndexOf("/") + 1);
                String url = "https://fa.wikipedia.org/w/index.php?title=" + name + "&printable=yes";
                Fetch(url);
                prb_fetch.setValue(num / 2 + i);
                String out = (num / 2 + i) + ": " + name;
                area_status_fetch.append(out + "\n");
            } catch (Exception ex) {
                area_status_fetch.append("Please Wait..., There is error\n");
                i--;
            }
            area_status_fetch.setCaretPosition(area_status_fetch.getText().length());
            if (!isThreadOn) {
                return;
            }
        }
        btn_browse_fetch.setEnabled(true);
        btn_fetch.setEnabled(true);
        prb_fetch.setValue(0);
        JOptionPane.showMessageDialog(null, "Download information from Wikipedia completed successfully", "Info", JOptionPane.INFORMATION_MESSAGE);
    }

    private void Fetch(String url) throws FileNotFoundException, IOException {
        Document d = Jsoup.connect(url).timeout(10000).get();
        String text = d.outerHtml();
        FileUtils.writeStringToFile(Paths.get(txt_dir_fetch.getText(), d.title() + ".html").toFile(), text, "UTF-8");
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea area_status_fetch;
    private javax.swing.JButton btn_browse_fetch;
    private javax.swing.JButton btn_fetch;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JProgressBar prb_fetch;
    private javax.swing.JTextField txt_dir_fetch;
    // End of variables declaration//GEN-END:variables
}
