
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.IOException;
import java.io.InputStream;
import java.io.ObjectInputStream;
import java.nio.file.Files;
import java.nio.file.LinkOption;
import java.nio.file.Path;
import java.nio.file.Paths;
import java.util.Arrays;
import java.util.Collection;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import org.apache.commons.io.FileUtils;
import org.apache.commons.io.filefilter.TrueFileFilter;
import org.apache.lucene.analysis.Analyzer;
import org.apache.lucene.analysis.core.KeywordAnalyzer;
import org.apache.lucene.analysis.standard.StandardAnalyzer;
import org.apache.lucene.document.Document;
import org.apache.lucene.document.Field;
import org.apache.lucene.document.FieldType;
import org.apache.lucene.document.StoredField;
import org.apache.lucene.document.StringField;
import org.apache.lucene.index.DirectoryReader;
import org.apache.lucene.index.IndexOptions;
import org.apache.lucene.index.IndexReader;
import org.apache.lucene.index.IndexWriter;
import org.apache.lucene.index.IndexWriterConfig;
import org.apache.lucene.search.spell.LuceneDictionary;
import org.apache.lucene.search.spell.SpellChecker;
import org.apache.lucene.store.Directory;
import org.apache.lucene.store.FSDirectory;
import org.apache.tika.Tika;
import org.apache.tika.exception.TikaException;
import org.apache.tika.language.LanguageIdentifier;
import org.apache.tika.metadata.Metadata;
import org.apache.tika.parser.AutoDetectParser;
import org.apache.tika.parser.ParseContext;
import org.apache.tika.parser.Parser;
import org.apache.tika.sax.BodyContentHandler;
import org.xml.sax.ContentHandler;

public class IndexFrame extends javax.swing.JDialog {

    static Info info;
    boolean isThreadOn = true;

    public IndexFrame() {
        initComponents();
        try {
            FileInputStream fis = new FileInputStream("Config.ini");
            ObjectInputStream ois = new ObjectInputStream(fis);
            info = (Info) ois.readObject();
            ois.close();
            fis.close();
            Arrays.sort(info.getContents());
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        jLabel1 = new javax.swing.JLabel();
        txt_dir = new javax.swing.JTextField();
        btn_browse = new javax.swing.JButton();
        btn_index = new javax.swing.JButton();
        jScrollPane1 = new javax.swing.JScrollPane();
        area_status = new javax.swing.JTextArea();
        prb_index = new javax.swing.JProgressBar();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Index files");
        setLocationByPlatform(true);
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                formWindowClosing(evt);
            }
        });

        jLabel1.setText("Directory:");

        txt_dir.setEditable(false);

        btn_browse.setText("Browse");
        btn_browse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_browseActionPerformed(evt);
            }
        });

        btn_index.setText("Index");
        btn_index.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_indexActionPerformed(evt);
            }
        });

        area_status.setEditable(false);
        area_status.setColumns(40);
        area_status.setRows(5);
        jScrollPane1.setViewportView(area_status);

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 617, Short.MAX_VALUE)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                    .addGap(8, 8, 8)
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                        .addGroup(layout.createSequentialGroup()
                            .addComponent(jLabel1)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(txt_dir)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(btn_browse)
                            .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                            .addComponent(btn_index))
                        .addComponent(prb_index, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 601, Short.MAX_VALUE))
                    .addGap(8, 8, 8)))
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGap(0, 381, Short.MAX_VALUE)
            .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                .addGroup(layout.createSequentialGroup()
                    .addContainerGap()
                    .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                        .addComponent(jLabel1)
                        .addComponent(txt_dir, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addComponent(btn_browse)
                        .addComponent(btn_index))
                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                    .addComponent(prb_index, javax.swing.GroupLayout.PREFERRED_SIZE, 30, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                    .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 294, Short.MAX_VALUE)
                    .addContainerGap()))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btn_browseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_browseActionPerformed
        JFileChooser open = new JFileChooser();
        open.setMultiSelectionEnabled(false);
        open.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        open.setDialogTitle("Open Directory");
        if (open.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
            txt_dir.setText(open.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_btn_browseActionPerformed

    private void btn_indexActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_indexActionPerformed

        try {
            Path p = Paths.get(txt_dir.getText());
            if (Files.exists(p) && Files.isDirectory(p, LinkOption.NOFOLLOW_LINKS)) {
                new Thread(new Runnable() {

                    @Override
                    public void run() {
                        area_status.setText("");
                        Path input = Paths.get(txt_dir.getText(), "");
                        createIndex(input);
                    }
                }).start();
            }
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_btn_indexActionPerformed

    private void formWindowClosing(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosing
        isThreadOn = false;
        this.dispose();
    }//GEN-LAST:event_formWindowClosing

    private void createSpellIndex(Path input) throws IOException {
        Path output = Paths.get(info.getIndexPath(), "");
        Directory dir = FSDirectory.open(Paths.get(output.toString(), "Spell"));
        SpellChecker spell = new SpellChecker(dir);
        Directory dir2 = FSDirectory.open(input);
        IndexReader r = DirectoryReader.open(dir2);
        Analyzer analyzer = new StandardAnalyzer();
        switch (info.getAnalyzer()) {
            case "Standard":
                analyzer = new StandardAnalyzer();
                break;
            case "Keyword":
                analyzer = new KeywordAnalyzer();
                break;
        }
        try {
            spell.indexDictionary(new LuceneDictionary(r, "body"), new IndexWriterConfig(analyzer), true);
        } catch (Exception ex) {
        } finally {
            r.close();
        }
        spell.close();
        dir.close();
        dir2.close();
    }

    private void createIndex(Path input) {
        try {
            btn_browse.setEnabled(false);
            btn_index.setEnabled(false);
            Path output = Paths.get(info.getIndexPath(), "");
            Paths.get(output.toString(), "Index").toFile().mkdir();
            Paths.get(output.toString(), "Spell").toFile().mkdir();
            FSDirectory directory = FSDirectory.open(Paths.get(output.toString(), "Index"));
            Analyzer analyzer = new StandardAnalyzer();
            switch (info.getAnalyzer()) {
                case "Standard":
                    analyzer = new StandardAnalyzer();
                    break;
                case "Keyword":
                    analyzer = new KeywordAnalyzer();
                    break;
            }
            IndexWriter writer = new IndexWriter(directory, new IndexWriterConfig(analyzer));
            Collection<File> docs = FileUtils.listFiles(input.toFile(), TrueFileFilter.INSTANCE, TrueFileFilter.INSTANCE);
            prb_index.setMaximum(docs.size());
            for (File f : docs) {
                Document d = getDocument(f);
                prb_index.setValue(prb_index.getValue() + 1);
                if (d == null) {
                    continue;
                }
                writer.addDocument(d);
                area_status.append(f.getName() + " has indexed\n");
                area_status.setCaretPosition(area_status.getText().length());
                if (!isThreadOn) {
                    writer.flush();
                    writer.close();
                    return;
                }
            }
            writer.flush();
            writer.close();
            createSpellIndex(Paths.get(output.toString(), "Index"));
            btn_browse.setEnabled(true);
            btn_index.setEnabled(true);
            prb_index.setValue(0);
            JOptionPane.showMessageDialog(null, "Index files and spell completed successfully", "Info", JOptionPane.INFORMATION_MESSAGE);
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }

    private Document getDocument(File f) throws FileNotFoundException, IOException, TikaException {
        Metadata metadata = new Metadata();
        metadata.set(Metadata.RESOURCE_NAME_KEY, f.getName());
        InputStream is = new FileInputStream(f);
        Parser parser = new AutoDetectParser();
        ContentHandler handler = new BodyContentHandler();
        ParseContext context = new ParseContext();
        context.set(Parser.class, parser);
        try {
            parser.parse(is, handler, metadata, context);
        } catch (Exception ex) {
        } finally {
            is.close();
        }
        Tika tika = new Tika();
        LanguageIdentifier li = new LanguageIdentifier(handler.toString());
        if (Arrays.binarySearch(info.getContents(), " " + tika.detect(f)) < 0) {
            return null;
        }
        Document doc = new Document();
        doc.add(new StringField("title", f.getName(), Field.Store.YES));
        FieldType ft = new FieldType();
        ft.setStoreTermVectorOffsets(true);
        ft.setStoreTermVectorPositions(true);
        ft.setStoreTermVectors(true);
        ft.setStoreTermVectorPayloads(true);
        ft.setTokenized(true);
        ft.setIndexOptions(IndexOptions.DOCS);
        ft.setStored(true);
        Field bodyField = new Field("body", handler.toString(), ft);
        doc.add(bodyField);
        doc.add(new StoredField("date", f.lastModified()));
        doc.add(new StringField("language", li.getLanguage(), Field.Store.YES));
        doc.add(new StringField("address", f.getAbsolutePath(), Field.Store.YES));
        doc.add(new StringField("type", tika.detect(f), Field.Store.YES));
        System.out.println(f.getName() + ": " + li.getLanguage());
        return doc;
    }

    public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new IndexFrame().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextArea area_status;
    private javax.swing.JButton btn_browse;
    private javax.swing.JButton btn_index;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JProgressBar prb_index;
    private javax.swing.JTextField txt_dir;
    // End of variables declaration//GEN-END:variables
}
