
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.ObjectInputStream;
import java.io.ObjectOutputStream;
import java.util.ArrayList;
import java.util.Enumeration;
import java.util.TreeMap;
import javax.swing.DefaultListModel;
import javax.swing.JFileChooser;
import javax.swing.JOptionPane;
import javax.swing.JRadioButton;
import javax.swing.tree.DefaultMutableTreeNode;
import javax.swing.tree.DefaultTreeModel;
import javax.swing.tree.MutableTreeNode;
import javax.swing.tree.TreeNode;

public class Settings extends javax.swing.JDialog {

    static TreeMap<String, JRadioButton> radio = new TreeMap<String, JRadioButton>();

    public Settings() {
        initComponents();
        lst_invalid.setModel(new DefaultListModel());
        rdo_levenshtein.setActionCommand(rdo_levenshtein.getText());
        radio.put(rdo_levenshtein.getText(), rdo_levenshtein);
        rdo_ngram.setActionCommand(rdo_ngram.getText());
        radio.put(rdo_ngram.getText(), rdo_ngram);
        rdo_Standard.setActionCommand(rdo_Standard.getText());
        radio.put(rdo_Standard.getText(), rdo_Standard);
        rdo_keyword.setActionCommand(rdo_keyword.getText());
        radio.put(rdo_keyword.getText(), rdo_keyword);
        rdo_boolean.setActionCommand(rdo_boolean.getText());
        radio.put(rdo_boolean.getText(), rdo_boolean);
        rdo_Phrase.setActionCommand(rdo_Phrase.getText());
        radio.put(rdo_Phrase.getText(), rdo_Phrase);
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        btngrp_spell = new javax.swing.ButtonGroup();
        btngrp_analyze = new javax.swing.ButtonGroup();
        btngrp_query = new javax.swing.ButtonGroup();
        pnl_content = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tre_types = new javax.swing.JTree();
        jScrollPane2 = new javax.swing.JScrollPane();
        lst_invalid = new javax.swing.JList();
        btn_add = new javax.swing.JButton();
        btn_delete = new javax.swing.JButton();
        pnl_spell = new javax.swing.JPanel();
        rdo_levenshtein = new javax.swing.JRadioButton();
        rdo_ngram = new javax.swing.JRadioButton();
        pnl_analyze = new javax.swing.JPanel();
        rdo_keyword = new javax.swing.JRadioButton();
        rdo_Standard = new javax.swing.JRadioButton();
        pnl_query = new javax.swing.JPanel();
        rdo_boolean = new javax.swing.JRadioButton();
        rdo_Phrase = new javax.swing.JRadioButton();
        btn_save = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jLabel1 = new javax.swing.JLabel();
        txt_index = new javax.swing.JTextField();
        btn_browse = new javax.swing.JButton();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Settings");
        setLocationByPlatform(true);
        setResizable(false);
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        pnl_content.setBorder(javax.swing.BorderFactory.createTitledBorder("Content types"));

        javax.swing.tree.DefaultMutableTreeNode treeNode1 = new javax.swing.tree.DefaultMutableTreeNode("Content types");
        javax.swing.tree.DefaultMutableTreeNode treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("ChmParser");
        javax.swing.tree.DefaultMutableTreeNode treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-htmlhelp");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-chm");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/chm");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("SourceCodeParser");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("text/x-c++src");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("text/x-groovy");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("text/x-java-source");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("HtmlParser");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("text/html");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.wap.xhtml+xml");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-asp");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/xhtml+xml");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("JackcessParser");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-msaccess");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("OfficeParser");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-tika-msoffice-embedded; format=ole10_native");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/msword");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.visio");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-project");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-tika-msworks-spreadsheet");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-mspublisher");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-powerpoint");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-tika-msoffice");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/sldworks");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-tika-ooxml-protected");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-excel");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-outlook");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("OldExcelParser");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-excel.workspace.3");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-excel.workspace.4");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-excel.sheet.2");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-excel.sheet.3");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-excel.sheet.4");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("OOXMLParser");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-word.document.macroenabled.12");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-excel.addin.macroenabled.12");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-tika-ooxml");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.openxmlformats-officedocument.wordprocessingml.template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-powerpoint.addin.macroenabled.12");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.openxmlformats-officedocument.spreadsheetml.template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.openxmlformats-officedocument.wordprocessingml.document");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.openxmlformats-officedocument.presentationml.template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-powerpoint.slideshow.macroenabled.12");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.openxmlformats-officedocument.presentationml.presentation");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-powerpoint.presentation.macroenabled.12");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.openxmlformats-officedocument.spreadsheetml.sheet");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.openxmlformats-officedocument.presentationml.slideshow");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-excel.template.macroenabled.12");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-excel.sheet.macroenabled.12");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.ms-word.template.macroenabled.12");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("OpenDocumentParser");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.presentation");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.chart");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.text-web");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.image");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.graphics-template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.text-web");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.spreadsheet-template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.spreadsheet-template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.sun.xml.writer");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.graphics-template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.graphics");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.spreadsheet");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.chart");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.spreadsheet");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.image");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.text");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.text-template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.formula-template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.formula");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.image-template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.image-template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.presentation-template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.presentation-template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.text");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.text-template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.chart-template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.chart-template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.formula-template");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.text-master");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.presentation");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/x-vnd.oasis.opendocument.graphics");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.formula");
        treeNode2.add(treeNode3);
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/vnd.oasis.opendocument.text-master");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("PDFParser");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/pdf");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("RTFParser");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/rtf");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("TXTParser");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("text/plain");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        treeNode2 = new javax.swing.tree.DefaultMutableTreeNode("DcXMLParser");
        treeNode3 = new javax.swing.tree.DefaultMutableTreeNode("application/xml");
        treeNode2.add(treeNode3);
        treeNode1.add(treeNode2);
        tre_types.setModel(new javax.swing.tree.DefaultTreeModel(treeNode1));
        tre_types.addTreeSelectionListener(new javax.swing.event.TreeSelectionListener() {
            public void valueChanged(javax.swing.event.TreeSelectionEvent evt) {
                tre_typesValueChanged(evt);
            }
        });
        jScrollPane1.setViewportView(tre_types);

        lst_invalid.setSelectionMode(javax.swing.ListSelectionModel.SINGLE_SELECTION);
        lst_invalid.addListSelectionListener(new javax.swing.event.ListSelectionListener() {
            public void valueChanged(javax.swing.event.ListSelectionEvent evt) {
                lst_invalidValueChanged(evt);
            }
        });
        jScrollPane2.setViewportView(lst_invalid);

        btn_add.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Icons/add.png"))); // NOI18N
        btn_add.setText("Add to invalid list");
        btn_add.setEnabled(false);
        btn_add.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btn_add.setPreferredSize(new java.awt.Dimension(113, 75));
        btn_add.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btn_add.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_addActionPerformed(evt);
            }
        });

        btn_delete.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Icons/delete.png"))); // NOI18N
        btn_delete.setText("<html>\n<div align='center'>\nDelete from invalid list\n<div>\n</html>");
        btn_delete.setEnabled(false);
        btn_delete.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btn_delete.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btn_delete.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_deleteActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout pnl_contentLayout = new javax.swing.GroupLayout(pnl_content);
        pnl_content.setLayout(pnl_contentLayout);
        pnl_contentLayout.setHorizontalGroup(
            pnl_contentLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_contentLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 223, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnl_contentLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(btn_add, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(btn_delete, javax.swing.GroupLayout.PREFERRED_SIZE, 0, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jScrollPane2, javax.swing.GroupLayout.PREFERRED_SIZE, 184, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap())
        );
        pnl_contentLayout.setVerticalGroup(
            pnl_contentLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_contentLayout.createSequentialGroup()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.PREFERRED_SIZE, 287, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
            .addComponent(jScrollPane2)
            .addGroup(pnl_contentLayout.createSequentialGroup()
                .addGap(57, 57, 57)
                .addComponent(btn_add, javax.swing.GroupLayout.PREFERRED_SIZE, 85, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btn_delete, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );

        pnl_spell.setBorder(javax.swing.BorderFactory.createTitledBorder("Spell Checking"));

        btngrp_spell.add(rdo_levenshtein);
        rdo_levenshtein.setSelected(true);
        rdo_levenshtein.setText("Levenshtein");

        btngrp_spell.add(rdo_ngram);
        rdo_ngram.setText("NGrams");

        javax.swing.GroupLayout pnl_spellLayout = new javax.swing.GroupLayout(pnl_spell);
        pnl_spell.setLayout(pnl_spellLayout);
        pnl_spellLayout.setHorizontalGroup(
            pnl_spellLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_spellLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnl_spellLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(rdo_levenshtein)
                    .addComponent(rdo_ngram))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pnl_spellLayout.setVerticalGroup(
            pnl_spellLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_spellLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(rdo_levenshtein)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(rdo_ngram)
                .addContainerGap())
        );

        pnl_analyze.setBorder(javax.swing.BorderFactory.createTitledBorder("Analyzer"));

        btngrp_analyze.add(rdo_keyword);
        rdo_keyword.setText("Keyword");

        btngrp_analyze.add(rdo_Standard);
        rdo_Standard.setSelected(true);
        rdo_Standard.setText("Standard");

        javax.swing.GroupLayout pnl_analyzeLayout = new javax.swing.GroupLayout(pnl_analyze);
        pnl_analyze.setLayout(pnl_analyzeLayout);
        pnl_analyzeLayout.setHorizontalGroup(
            pnl_analyzeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_analyzeLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnl_analyzeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(rdo_Standard)
                    .addComponent(rdo_keyword))
                .addContainerGap(30, Short.MAX_VALUE))
        );
        pnl_analyzeLayout.setVerticalGroup(
            pnl_analyzeLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_analyzeLayout.createSequentialGroup()
                .addContainerGap()
                .addComponent(rdo_Standard)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(rdo_keyword))
        );

        pnl_query.setBorder(javax.swing.BorderFactory.createTitledBorder("Query"));

        btngrp_query.add(rdo_boolean);
        rdo_boolean.setSelected(true);
        rdo_boolean.setText("Boolean");

        btngrp_query.add(rdo_Phrase);
        rdo_Phrase.setText("Phrase");

        javax.swing.GroupLayout pnl_queryLayout = new javax.swing.GroupLayout(pnl_query);
        pnl_query.setLayout(pnl_queryLayout);
        pnl_queryLayout.setHorizontalGroup(
            pnl_queryLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_queryLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnl_queryLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(rdo_boolean)
                    .addComponent(rdo_Phrase))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pnl_queryLayout.setVerticalGroup(
            pnl_queryLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_queryLayout.createSequentialGroup()
                .addComponent(rdo_boolean)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(rdo_Phrase))
        );

        btn_save.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Icons/accept.png"))); // NOI18N
        btn_save.setText("Apply");
        btn_save.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_saveActionPerformed(evt);
            }
        });

        jPanel1.setBorder(javax.swing.BorderFactory.createTitledBorder("Index files directory"));

        jLabel1.setText("Directory:");

        txt_index.setEditable(false);

        btn_browse.setText("Browse");
        btn_browse.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_browseActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(jLabel1)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(txt_index)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(btn_browse)
                .addGap(4, 4, 4))
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                .addComponent(jLabel1)
                .addComponent(txt_index, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addComponent(btn_browse))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(pnl_content, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(pnl_spell, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(pnl_analyze, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(pnl_query, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(btn_save, javax.swing.GroupLayout.DEFAULT_SIZE, 117, Short.MAX_VALUE))
                .addContainerGap())
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(pnl_spell, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                        .addComponent(pnl_analyze, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addComponent(pnl_query, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(btn_save, javax.swing.GroupLayout.PREFERRED_SIZE, 57, javax.swing.GroupLayout.PREFERRED_SIZE))
                    .addGroup(layout.createSequentialGroup()
                        .addComponent(pnl_content, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                        .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void tre_typesValueChanged(javax.swing.event.TreeSelectionEvent evt) {//GEN-FIRST:event_tre_typesValueChanged
        if (evt.getNewLeadSelectionPath() != null && evt.getNewLeadSelectionPath().getPathCount() == 3) {
            btn_add.setEnabled(true);
        } else {
            btn_add.setEnabled(false);
        }
    }//GEN-LAST:event_tre_typesValueChanged


    private void btn_addActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_addActionPerformed
        DefaultTreeModel treemodel = (DefaultTreeModel) tre_types.getModel();
        DefaultListModel model = (DefaultListModel) lst_invalid.getModel();
        DefaultMutableTreeNode root = (DefaultMutableTreeNode) treemodel.getRoot();
        DefaultMutableTreeNode sel = (DefaultMutableTreeNode) tre_types.getSelectionPath().getParentPath().getLastPathComponent();
        int level = 0;
        for(int i=0;i<12;i++){
            if(root.getChildAt(i).equals(sel)){
                level = i;
                break;
            }
        }
        String value = tre_types.getSelectionPath().getLastPathComponent().toString();        
        model.addElement(new Node(level, value));
        treemodel.removeNodeFromParent(((MutableTreeNode) tre_types.getSelectionPath().getLastPathComponent()));
        lst_invalid.setSelectedIndex(0);
    }//GEN-LAST:event_btn_addActionPerformed

    private void btn_deleteActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_deleteActionPerformed
        Node node = (Node) lst_invalid.getSelectedValue();
        DefaultTreeModel treemodel = (DefaultTreeModel) tre_types.getModel();
        DefaultMutableTreeNode root = (DefaultMutableTreeNode) treemodel.getRoot();
        DefaultMutableTreeNode child = (DefaultMutableTreeNode) root.getChildAt(node.level);
        child.add(new DefaultMutableTreeNode(node.value));
        treemodel.reload(root);
        DefaultListModel model = (DefaultListModel) lst_invalid.getModel();
        model.removeElementAt(lst_invalid.getSelectedIndex());
        btn_delete.setEnabled(false);
    }//GEN-LAST:event_btn_deleteActionPerformed

    private void lst_invalidValueChanged(javax.swing.event.ListSelectionEvent evt) {//GEN-FIRST:event_lst_invalidValueChanged
        if (evt.getLastIndex() > -1) {
            btn_delete.setEnabled(true);
        } else {
            btn_delete.setEnabled(false);
        }
    }//GEN-LAST:event_lst_invalidValueChanged

    private void btn_browseActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_browseActionPerformed
        JFileChooser open = new JFileChooser();
        open.setMultiSelectionEnabled(false);
        open.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
        open.setDialogTitle("Open Directory");
        if (open.showOpenDialog(null) == JFileChooser.APPROVE_OPTION) {
            txt_index.setText(open.getSelectedFile().getPath());
        }
    }//GEN-LAST:event_btn_browseActionPerformed

    private void btn_saveActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_saveActionPerformed
        Info info = new Info();
        info.setAnalyzer(btngrp_analyze.getSelection().getActionCommand());
        info.setIndexPath(txt_index.getText());
        info.setQuery(btngrp_query.getSelection().getActionCommand());
        info.setStringDistance(btngrp_spell.getSelection().getActionCommand());
        ArrayList<String> contents = new ArrayList<>();
        DefaultTreeModel treemodel = (DefaultTreeModel) tre_types.getModel();
        DefaultMutableTreeNode value = (DefaultMutableTreeNode) treemodel.getRoot();
        Enumeration root = value.children();
        while (root.hasMoreElements()) {
            DefaultMutableTreeNode child = (DefaultMutableTreeNode) root.nextElement();
            Enumeration types = child.children();
            contents.add(child.toString());
            while (types.hasMoreElements()) {
                DefaultMutableTreeNode type = (DefaultMutableTreeNode) types.nextElement();
                contents.add(" " + type.toString());
            }
        }
        info.setContents(contents.toArray(new String[0]));
        ArrayList<Node> invalid = new ArrayList<>();
        DefaultListModel model = (DefaultListModel) lst_invalid.getModel();
        Enumeration list = model.elements();
        while (list.hasMoreElements()) {
            invalid.add((Node) list.nextElement());
        }
        info.setInvalidList(invalid.toArray(new Node[0]));
        try {
            FileOutputStream fos = new FileOutputStream("Config.ini");
            ObjectOutputStream oos = new ObjectOutputStream(fos);
            oos.writeObject(info);
            oos.close();
            fos.close();
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
        dispose();
    }//GEN-LAST:event_btn_saveActionPerformed

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
        try {
            FileInputStream fis = new FileInputStream("Config.ini");
            ObjectInputStream ois = new ObjectInputStream(fis);
            Info info = (Info) ois.readObject();
            ois.close();
            fis.close();
            radio.get(info.getAnalyzer()).setSelected(true);
            radio.get(info.getQuery()).setSelected(true);
            radio.get(info.getStringDistance()).setSelected(true);
            String[] contents = info.getContents();
            Node[] invalid = info.getInvalidList();
            TreeNode root = new DefaultMutableTreeNode("Content types");
            tre_types.setModel(new DefaultTreeModel(root));
            DefaultTreeModel treemodel = (DefaultTreeModel) tre_types.getModel();
            DefaultMutableTreeNode rootNode = (DefaultMutableTreeNode) treemodel.getRoot();
            DefaultMutableTreeNode childNode = null;
            for(String str:contents){
                if(str.charAt(0) == ' '){
                    childNode.add(new DefaultMutableTreeNode(str.substring(1)));
                }else{
                    rootNode.add(new DefaultMutableTreeNode(str));
                    childNode = (DefaultMutableTreeNode)root.getChildAt(root.getChildCount()-1);
                }
            }
            treemodel.reload(root);
            DefaultListModel model = (DefaultListModel) lst_invalid.getModel();
            for(Node node:invalid){
                model.addElement(node);
            }
            txt_index.setText(info.getIndexPath());
        } catch (Exception ex) {
            JOptionPane.showMessageDialog(null, ex.getMessage(), "Error", JOptionPane.ERROR_MESSAGE);
        }
    }//GEN-LAST:event_formWindowOpened

    public static void main(String args[]) {

        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Settings().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btn_add;
    private javax.swing.JButton btn_browse;
    private javax.swing.JButton btn_delete;
    private javax.swing.JButton btn_save;
    private javax.swing.ButtonGroup btngrp_analyze;
    private javax.swing.ButtonGroup btngrp_query;
    private javax.swing.ButtonGroup btngrp_spell;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JScrollPane jScrollPane1;
    private javax.swing.JScrollPane jScrollPane2;
    private javax.swing.JList lst_invalid;
    private javax.swing.JPanel pnl_analyze;
    private javax.swing.JPanel pnl_content;
    private javax.swing.JPanel pnl_query;
    private javax.swing.JPanel pnl_spell;
    private javax.swing.JRadioButton rdo_Phrase;
    private javax.swing.JRadioButton rdo_Standard;
    private javax.swing.JRadioButton rdo_boolean;
    private javax.swing.JRadioButton rdo_keyword;
    private javax.swing.JRadioButton rdo_levenshtein;
    private javax.swing.JRadioButton rdo_ngram;
    private javax.swing.JTree tre_types;
    private javax.swing.JTextField txt_index;
    // End of variables declaration//GEN-END:variables
}
