
import javax.swing.ImageIcon;
import javax.swing.UIManager;

public class Setup extends javax.swing.JFrame {

    public Setup() {
        initComponents();
    }

    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        pnl_tools = new javax.swing.JPanel();
        btn_getwiki = new javax.swing.JButton();
        btn_settings = new javax.swing.JButton();
        btn_create = new javax.swing.JButton();
        btn_exit = new javax.swing.JButton();
        jLabel2 = new javax.swing.JLabel();
        jPanel1 = new javax.swing.JPanel();
        lbl_status = new javax.swing.JLabel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setTitle("Search Engine Configuration");
        setIconImage(new ImageIcon(getClass().getResource("seo-big-blue.png")).getImage());
        setLocationByPlatform(true);
        setResizable(false);

        pnl_tools.setBorder(javax.swing.BorderFactory.createTitledBorder("Tools"));

        btn_getwiki.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Icons/wikipedia.png"))); // NOI18N
        btn_getwiki.setText("Random pages of Wikipedia");
        btn_getwiki.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btn_getwiki.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btn_getwiki.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                btn_getwikiMouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                btn_getwikiMouseExited(evt);
            }
        });
        btn_getwiki.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_getwikiActionPerformed(evt);
            }
        });

        btn_settings.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Icons/advancedsettings.png"))); // NOI18N
        btn_settings.setText("Settings");
        btn_settings.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btn_settings.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btn_settings.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                btn_settingsMouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                btn_settingsMouseExited(evt);
            }
        });
        btn_settings.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_settingsActionPerformed(evt);
            }
        });

        btn_create.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Icons/pr2.png"))); // NOI18N
        btn_create.setText("Create Index Files");
        btn_create.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btn_create.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btn_create.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                btn_createMouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                btn_createMouseExited(evt);
            }
        });
        btn_create.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_createActionPerformed(evt);
            }
        });

        btn_exit.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Icons/log-out.png"))); // NOI18N
        btn_exit.setText("Exit");
        btn_exit.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btn_exit.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);
        btn_exit.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseEntered(java.awt.event.MouseEvent evt) {
                btn_exitMouseEntered(evt);
            }
            public void mouseExited(java.awt.event.MouseEvent evt) {
                btn_exitMouseExited(evt);
            }
        });
        btn_exit.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btn_exitActionPerformed(evt);
            }
        });

        javax.swing.GroupLayout pnl_toolsLayout = new javax.swing.GroupLayout(pnl_tools);
        pnl_tools.setLayout(pnl_toolsLayout);
        pnl_toolsLayout.setHorizontalGroup(
            pnl_toolsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_toolsLayout.createSequentialGroup()
                .addContainerGap()
                .addGroup(pnl_toolsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(btn_create, javax.swing.GroupLayout.DEFAULT_SIZE, 180, Short.MAX_VALUE)
                    .addComponent(btn_getwiki, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnl_toolsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING, false)
                    .addComponent(btn_settings, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(btn_exit, javax.swing.GroupLayout.DEFAULT_SIZE, 180, Short.MAX_VALUE))
                .addContainerGap(javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
        );
        pnl_toolsLayout.setVerticalGroup(
            pnl_toolsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(pnl_toolsLayout.createSequentialGroup()
                .addGroup(pnl_toolsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.TRAILING, false)
                    .addComponent(btn_settings, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(btn_getwiki, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(pnl_toolsLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(btn_create, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
                    .addComponent(btn_exit, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)))
        );

        jLabel2.setFont(new java.awt.Font("Tahoma", 0, 36)); // NOI18N
        jLabel2.setIcon(new javax.swing.ImageIcon(getClass().getResource("/Icons/seo-big-blue.png"))); // NOI18N
        jLabel2.setText("<html> <body> <div align='center'> Persia<br/>Search Engine </div> </body> </html>");
        jLabel2.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        jLabel2.setVerticalTextPosition(javax.swing.SwingConstants.BOTTOM);

        jPanel1.setBorder(javax.swing.BorderFactory.createEtchedBorder());

        lbl_status.setText("Please select a item in Tools");
        lbl_status.setPreferredSize(new java.awt.Dimension(30, 14));

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(lbl_status, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addComponent(lbl_status, javax.swing.GroupLayout.PREFERRED_SIZE, 25, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 0, Short.MAX_VALUE))
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(pnl_tools, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, 230, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addContainerGap(16, Short.MAX_VALUE))
            .addComponent(jPanel1, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addGroup(layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addComponent(pnl_tools, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                    .addGroup(layout.createSequentialGroup()
                        .addGap(42, 42, 42)
                        .addComponent(jLabel2, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED, 22, Short.MAX_VALUE)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void btn_getwikiMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_getwikiMouseEntered
        lbl_status.setText("Download random pages from Wikipedia and save them in Wikipedia directory to index.");
    }//GEN-LAST:event_btn_getwikiMouseEntered

    private void btn_getwikiMouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_getwikiMouseExited
        lbl_status.setText("Please select a item in Tools.");
    }//GEN-LAST:event_btn_getwikiMouseExited

    private void btn_settingsMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_settingsMouseEntered
        lbl_status.setText("Change settings related to my search engine.");
    }//GEN-LAST:event_btn_settingsMouseEntered

    private void btn_settingsMouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_settingsMouseExited
        lbl_status.setText("Please select a item in Tools.");
    }//GEN-LAST:event_btn_settingsMouseExited

    private void btn_createMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_createMouseEntered
        lbl_status.setText("Create search engine index files based on the settings.");
    }//GEN-LAST:event_btn_createMouseEntered

    private void btn_createMouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_createMouseExited
        lbl_status.setText("Please select a item in Tools.");
    }//GEN-LAST:event_btn_createMouseExited

    private void btn_exitMouseEntered(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_exitMouseEntered
        lbl_status.setText("Create search engine index files for spell checking based on the settings.");
    }//GEN-LAST:event_btn_exitMouseEntered

    private void btn_exitMouseExited(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btn_exitMouseExited
        lbl_status.setText("Please select a item in Tools.");
    }//GEN-LAST:event_btn_exitMouseExited

    private void btn_exitActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_exitActionPerformed
        this.dispose();
    }//GEN-LAST:event_btn_exitActionPerformed

    private void btn_getwikiActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_getwikiActionPerformed
        FetchWiki fetchWiki = new FetchWiki();
        fetchWiki.setModal(true);
        fetchWiki.setVisible(true);
    }//GEN-LAST:event_btn_getwikiActionPerformed

    private void btn_settingsActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_settingsActionPerformed
        Settings settings = new Settings();
        settings.setModal(true);
        settings.setVisible(true);
    }//GEN-LAST:event_btn_settingsActionPerformed

    private void btn_createActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btn_createActionPerformed
        IndexFrame indexFrame = new IndexFrame();
        indexFrame.setModal(true);
        indexFrame.setVisible(true);
    }//GEN-LAST:event_btn_createActionPerformed

    public static void main(String args[]) {
        
        try{
            UIManager.setLookAndFeel("javax.swing.plaf.nimbus.NimbusLookAndFeel");
            
        }catch(Exception ex){
            
        }
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new Setup().setVisible(true);
            }
        });
    }

    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton btn_create;
    private javax.swing.JButton btn_exit;
    private javax.swing.JButton btn_getwiki;
    private javax.swing.JButton btn_settings;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JPanel jPanel1;
    private javax.swing.JLabel lbl_status;
    private javax.swing.JPanel pnl_tools;
    // End of variables declaration//GEN-END:variables
}
